var fs = require('fs')
var path = require('path')

module.exports = function(content) {

    if(this.resourcePath.indexOf('node_modules') === -1) {

        // 指定引入 sass 的 js
        if(!this._compiler.sassImporter) {
            var sassEntryFilePath = path.join(__dirname, 'onceImporter.scss')

            this._compiler.sassImporter = {
                sassImporterPath: this.resource,
                sassEntryFilePath: sassEntryFilePath,
                sassEntries: []
            }

            fs.writeFileSync(sassEntryFilePath, '')

            content += 'require("' + sassEntryFilePath + '");'

        } else if(this.resource === this._compiler.sassImporter.sassImporterPath) {
            content += 'require("' + this._compiler.sassImporter.sassEntryFilePath + '");'
        }

        // 匹配 @import "path/xxxx";
        var self = this
        content = content.replace(/(import\s.*)|(require\(.*\))/g, function(importStatement) {

            // 匹配 "path/xxxx";
            var replacedImportStatement = importStatement.replace(/[\'\"]([^\'^\"]+)[\'\"]/g, function(match, modulePath) {
                if(modulePath.indexOf('onceImporter.scss') > -1) {
                    return match
                }

                var extname = path.extname(modulePath)
                var sassResolvePath = ''

                // 寻找不带后缀引用的 scss 文件
                if(extname === '') {
                    var possibleSassPath = path.resolve(self.context, modulePath + ".sass")
                    var possibleScssPath = path.resolve(self.context, modulePath + ".scss")
                    if(fileExists(possibleSassPath) || fileExists(possibleScssPath)) {
                        sassResolvePath = path.resolve(self.context, modulePath)
                    }
                }

                // 寻找 .sass 和 .scss 文件
                if(extname === '.sass' || extname === '.scss') {
                    if(fileExists(path.resolve(self.context, modulePath))) {
                        sassResolvePath = path.resolve(self.context, modulePath)
                    }
                }

                // 将引用语句从原 js 移到 sass 入口文件中
                if(sassResolvePath && self._compiler.sassImporter) {
                    if(self._compiler.sassImporter.sassEntries.indexOf(sassResolvePath) === -1) {
                        self._compiler.sassImporter.sassEntries.push(sassResolvePath)
                        fs.appendFileSync(self._compiler.sassImporter.sassEntryFilePath, '@import "' + sassResolvePath + '";\n')
                    }
                    return 'removedScssPath'
                } else {
                    return match
                }
            })

            // 如果发现有引入 sass 的语句，删除它
            if(replacedImportStatement.indexOf('removedScssPath') > -1) {
                return ''
            } else {
                return importStatement
            }
        })
    }

    return content
}

function fileExists(filepath) {
    try {
		return fs.statSync(filepath).isFile()
	} catch (err) {
		return false
	}
}
